PROGRAM CATDEDUP; {Program to eliminate duplicates from *.CAT files generated
                     by TAPCIS}

{Version 1.1 - 1/11/91}

{COPYRIGHT 1990-1991 by Stephen L. Haynes; CompuServe ID 76236,3547}

USES CRT,DOS;

TYPE

  String9 = STRING[9];

VAR

  DirInfo                               : SearchRec;

  RootName                              : STRING;
  InFile,OutFile,TempFile               : TEXT;

  Name_Array                            : ARRAY[1..100] OF STRING[12];
  N,MaxN                                : BYTE;
  NameFound                             : BOOLEAN;

  Answer                                : STRING[1];
  MakeBackup                            : BOOLEAN;
  Ch                                    : CHAR;
  FileDateTime                          : LONGINT;

PROCEDURE PROCESS(InFileName:STRING;VAR FileDateTime:LONGINT);

CONST

  Month_String = 'JanFebMarAprMayJunJulAugSepOctNovDec';

TYPE

  Title = RECORD

      Name  : STRING[10];
      ID    : STRING[10];
      Day   : STRING[2];
      Month : STRING[3];
      Year  : STRING[2];
      Dupe  : BOOLEAN;
      Order : POINTER;
      Next  : POINTER
    END;

  TitlePntr = ^Title;

  Alphas = RECORD

      Letter : STRING[1];
      Next   : POINTER;
      Skip   : POINTER
    END;

  AlphaPntr = ^Alphas;

VAR

  A_Place                               : Alphas;
  A_Pntr                                : AlphaPntr;
  Base_A_Pntr                           : AlphaPntr;
  Last_A_Pntr                           : AlphaPntr;

  Desc                                  : Title;
  DescPntr                              : TitlePntr;
  Last_D_Pntr                           : TitlePntr;
  OrderPntr                             : TitlePntr;

  FirstPntr                             : POINTER;

  ThisPntr                              : POINTER;

  N,FirstSpace,FirstSlash,FirstPeriod   : BYTE;
  FirstChar                             : STRING[1];
  Count,DupeCnt                         : WORD;
  Filler                                : STRING[10];
  ThisDate                              : STRING[9];
  FirstNIL                              : BOOLEAN;

  ThisDay,ThisYear                      : STRING[2];
  ThisMonth                             : STRING[3];
  FirstMonthPos,ThisMonthPos            : WORD;

  InName,InID                           : STRING[10];

  RootName                              : STRING;
  InFile,OutFile                        : TEXT;
  InText                                : STRING[85];

BEGIN

  {$I-}

  IF (POS('.CAT',InFileName) = 0) AND (POS('.',InFileName) = 0) THEN
    {if filename has no extension}

    InFileName := InFileName+'.CAT';

  FOR N := 1 TO LENGTH(InFileName) DO InFileName[N] := UPCASE(InFileName[N]);

  WRITELN('PROCESSING FILE:  ',InFileName);
  WRITELN('  Analyzing');

  ASSIGN(InFile,InFileName);
  RESET(InFile);

  IF IOResult <> 0 THEN {if erroneous path/file name, program terminates}
    BEGIN
      CLRSCR;
      FOR N := 1 TO 5 DO WRITELN('');
      WRITELN('     Filename ',InFileName,' does not exist.');
      WRITELN('     Please try again.');

      EXIT
    END;

  {$I+}

  GETFTIME(InFile,FileDateTime); {capture date & time of original file, for
                                  transfer to target file at later point}

  Filler := '          ';

  NEW(A_Pntr);
  Base_A_Pntr := A_Pntr;
  Last_A_Pntr := A_Pntr;
  NEW(DescPntr);

  A_Pntr^.Letter := '0'; {initialize lowest heap entry}
  A_Pntr^.Next := DescPntr;

  {create very first name/ID entry}

  Last_D_Pntr := A_Pntr^.Next;

  Last_D_Pntr^.Name := '0'+Filler;
  Last_D_Pntr^.ID := '00000,0000';
  Last_D_Pntr^.Dupe := FALSE;

  NEW(DescPntr);

  Last_D_Pntr^.Next := DescPntr;

  {create last possible name/ID entry for this character}

  DescPntr^.Name := '9ZZZZZZZZZ';
  DescPntr^.ID := '99999,9999';
  DescPntr^.Dupe := FALSE;
  DescPntr^.Next := NIL;

  NEW(A_Pntr);

  Last_A_Pntr^.Skip := A_Pntr;

  FOR N := 65 TO 90 DO
    BEGIN

      NEW(DescPntr);

      A_Pntr^.Letter := CHR(N); {initialize next alphabetic heap entry}
      A_Pntr^.Next := DescPntr;

      {create first name/ID entry for each alphabetic letter}

      Last_D_Pntr := A_Pntr^.Next;

      Last_D_Pntr^.Name := CHR(N)+Filler;
      Last_D_Pntr^.ID := '00000,0000';
      Last_D_Pntr^.Dupe := FALSE;

      NEW(DescPntr);

      Last_D_Pntr^.Next := DescPntr;

      {create last possible name/ID entry for each alphabetic letter}

      DescPntr^.Name := CHR(N)+'ZZZZZZZZZ';
      DescPntr^.ID := '99999,9999';
      DescPntr^.Dupe := FALSE;
      DescPntr^.Next := NIL;

      Last_A_Pntr := A_Pntr;

      NEW(A_Pntr);

      Last_A_Pntr^.Skip := A_Pntr;
    END;

  A_Pntr^.Letter := '~'; {initialize last alphabetic heap entry}
  A_Pntr^.Next := NIL;
  A_Pntr^.Skip := NIL;

  DupeCnt := 0;
  Count := 0;
  FirstPntr := NIL; {set condition to indicate when very first entry from
                     catalog files is placed on heap}

  READLN(InFile,InText);

  WHILE NOT EOF(InFile) AND (InText[1] <> '[') DO READLN(InFile,InText);
    {read until first Catalog entry encountered}

  WHILE NOT EOF(InFile) AND (MEMAVAIL > 1000) DO {first pass through
    Catalog file, building heap}

    BEGIN

      InID := COPY(InText,2,POS(']',InText)-2)+Filler;

      READLN(InFile,InText);

      FirstPeriod := POS('.',InText);
      FirstSlash := POS('/',InText);
      FirstSpace := POS(' ',InText);

      IF (FirstSlash < FirstSpace) AND (FirstSlash > FirstPeriod) THEN
        FirstSpace := FirstSlash;

      InName := COPY(InText,1,FirstSpace-1)+Filler;

      FirstChar := InName[1]; {FirstChar is used to move through A_Place}

      ThisDate := COPY(InText,27,9);

      ThisDay := COPY(ThisDate,1,2); {initialize date segments}
      ThisMonth := COPY(ThisDate,4,3);
      ThisYear := COPY(ThisDate,8,2);

      ThisMonthPos := POS(ThisMonth,Month_String); {position of current month
        within Month_String}

      A_Pntr := Base_A_Pntr; {point to beginning of alphabetic heap}

      WHILE A_Pntr^.Letter <= FirstChar DO {move through alphabetic heap until
        find correct first character}

        BEGIN

          Last_A_Pntr := A_Pntr;
          A_Pntr := Last_A_Pntr^.Skip
        END;

      DescPntr := Last_A_Pntr^.Next;

      WHILE (DescPntr^.Name+DescPntr^.ID < InName+InID) DO {move through
              alphabetized heap until reach correct spot or run out
              of entries for this first character}

        BEGIN

          Last_D_Pntr := DescPntr;
          DescPntr := DescPntr^.Next
        END;

      IF DescPntr^.Name+DescPntr^.ID > InName+InID THEN
        {if entries are not possible duplicates, shift pointer to next
         previous entry on heap}

        DescPntr := Last_D_Pntr;

      WHILE DescPntr^.Dupe AND (DescPntr^.Name+DescPntr^.ID = InName+InID) DO
        {move through duplicate entries already marked}

        BEGIN

          Last_D_Pntr := DescPntr;
          DescPntr := DescPntr^.Next
        END;

      Last_D_Pntr := DescPntr;

      {create new entry on heap}

      NEW(DescPntr);

      INC(Count);

      IF FirstPntr = NIL THEN {if this is the very first entry, then
        initiate order pointers}

        BEGIN

          FirstPntr := DescPntr;
          OrderPntr := DescPntr
        END;

      IF Last_D_Pntr^.Name+Last_D_Pntr^.ID = InName+InID THEN
        {if duplicate entry, other than dates}

        BEGIN

          FirstMonthPos := POS(Last_D_Pntr^.Month,Month_String);

          IF (ThisDay+ThisMonth+ThisYear = Last_D_Pntr^.Day+Last_D_Pntr^.Month+
              Last_D_Pntr^.Year)
            {if dates are equal, then first entry is considered to be
             duplicate, so ...}
             OR
            (Last_D_Pntr^.Year < ThisYear) OR
             ((Last_D_Pntr^.Year = ThisYear) AND
              (FirstMonthPos < ThisMonthPos)) OR
             ((Last_D_Pntr^.Year = ThisYear) AND
              (FirstMonthPos = ThisMonthPos) AND
              (Last_D_Pntr^.Day < ThisDay)) THEN
            {if heap date is older than this date, then ...}

            BEGIN

              Last_D_Pntr^.Dupe := TRUE; {mark last entry as duplicate}
              DescPntr^.Dupe := FALSE;

              INC(DupeCnt)
            END
            ELSE {current entry in heap has newer date, therefore new
                 {entry should be marked as dupe}

              BEGIN

                Last_D_Pntr^.Dupe := FALSE; {mark last entry as non-duplicate}
                DescPntr^.Dupe := TRUE;

                INC(DupeCnt)
              END
        END
        ELSE DescPntr^.Dupe := FALSE;

      {fill new heap entry with current data, mark it as the
       non-duplicate entry, and adjust pointers}

      DescPntr^.Name := InName;
      DescPntr^.ID := InID;
      DescPntr^.Day := ThisDay;
      DescPntr^.Month := ThisMonth;
      DescPntr^.Year := ThisYear;
      DescPntr^.Next := Last_D_Pntr^.Next;

      Last_D_Pntr^.Next := DescPntr;

      OrderPntr^.Order := DescPntr; {adjust pointer to linear
        order of heap}
      OrderPntr := DescPntr;
      DescPntr^.Order := NIL;

      WHILE NOT EOF(InFile) AND (InText[1] <> '[') AND (MEMAVAIL > 1000) DO
        READLN(InFile,InText) {read until next Catalog entry encountered}

    END;

  WRITELN('  Found ',DupeCnt:6,' Duplicates in ',Count:6,' entries');

  IF MEMAVAIL <= 1000 THEN {if ran out of heap memory}
    BEGIN
      WRITELN('  **NOTICE** : This Catalog contained more entries than could');
      WRITELN('               be processed in a single pass. You may wish to');
      WRITELN('               consider a second pass.');
      WRITELN('');
      WRITELN('  Press any key to continue ...');

      Ch := READKEY
    END;

  IF DupeCnt <> 0 THEN {if some dupes were found}

    BEGIN

      RESET(InFile);

      RootName := COPY(InFileName,1,POS('.',InFileName)-1);

      {$I-}

      ASSIGN(OutFile,RootName+'.$$$');
      REWRITE(OutFile);

      IF IOResult <> 0 THEN;

      {$I+}

      READLN(InFile,InText);

      WHILE NOT EOF(InFile) AND (InText[1] <> '[') DO
        {transfer lines until first Catalog entry encountered}

        BEGIN

          WRITELN(OutFile,InText);
          READLN(InFile,InText)
        END;

      WRITELN('  De-Duping');

      OrderPntr := FirstPntr;

      WHILE NOT EOF(InFile) DO

        BEGIN

          InID := COPY(InText,2,POS(']',InText)-2)+Filler;

          IF OrderPntr^.Dupe AND (OrderPntr^.ID = InID) THEN
            {still in the heap and current entry is a duplicate of a later
            entry}

            BEGIN

              {read through current entry without outputting text}

              FOR N := 1 TO 3 DO
                READLN(InFile,InText);

              WHILE NOT EOF(InFile) AND (LENGTH(InText) > 1)
                  AND (InText[1] <> '[') DO
                READLN(InFile,InText);

              WHILE NOT EOF(InFile) AND (LENGTH(InText) <= 1)
                  AND (InText[1] <> '[') DO
                READLN(InFile,InText);

              WHILE NOT EOF(InFile) AND (InText[1] <> '[') DO
                {transfer lines until next Catalog entry encountered}

                BEGIN

                  WRITELN(OutFile,InText);
                  READLN(InFile,InText)
                END
            END
            ELSE

              IF NOT OrderPntr^.Dupe THEN
                {if still in the heap and current entry is not a duplicate}

                BEGIN

                  {transfer all lines in current entry}

                  WRITELN(OutFile,InText);
                  READLN(InFile,InText);

                  WHILE NOT EOF(InFile) AND (InText[1] <> '[') DO
                    {transfer lines until next Catalog entry encountered}

                    BEGIN

                      WRITELN(OutFile,InText);
                      READLN(InFile,InText)
                    END
                END
                ELSE

                  IF OrderPntr^.ID <> InID THEN

                    {the duplicate markers do not match up with the file
                    being processed.  Some kind of problem locating '[' in
                    the first character of lines, or some problem with spacing;
                    in this instance, the routine just renames the original
                    file to a *.$$$ file and exits}

                    BEGIN

                      WRITELN('  ERROR IN MATCHING ENTRIES');
                      WRITELN('  FILE NOT PROCESSED');

                      CLOSE(InFile);
                      CLOSE(OutFile);

                      RootName := COPY(InFileName,1,POS('.',InFileName)-1);

                      {$I-}

                      RENAME(InFile,RootName+'.$$$');

                      IF IOResult <> 0 THEN;

                      {$I+}

                      EXIT
                    END;

          IF OrderPntr^.Order = NIL THEN {if reached end of heap, transfer
            all lines}

            WHILE NOT EOF(InFile) DO {transfer all remaining lines}

              BEGIN

                WRITELN(OutFile,InText);
                READLN(InFile,InText)
              END;

          OrderPntr := OrderPntr^.Order
        END;

      CLOSE(InFile);
      FLUSH(OutFile);
      CLOSE(OutFile)
    END
    ELSE {simply rename catalog file to working output file}

      BEGIN

        CLOSE(InFile);

        RootName := COPY(InFileName,1,POS('.',InFileName)-1);

        {$I-}

        RENAME(InFile,RootName+'.$$$');

        IF IOResult <> 0 THEN;

        WRITELN('  No changes; no backup made.')

        {$I+}
      END;

  RELEASE(HeapOrg)
END;

BEGIN

  CLRSCR;

  WRITELN('CATDEDUP, the CATALOG de-duplication program (v. 1.1).');
  WRITELN('  Copyright 1990-1991 by Stephen L. Haynes.');

  IF PARAMCOUNT = 0 THEN {if no parameters, program terminates}
    BEGIN
      WRITELN('');
      WRITELN('     You must enter a filename for the Catalog');
      WRITELN('     to be processed.');
      WRITELN('');
      WRITELN('     Use form');
      WRITELN('       CATDEDUP [filename]');
      WRITELN('     to dedupe a single file, or');
      WRITELN('       CATDEDUP /A');
      WRITELN('     to dedupe all files in this directory');
      WRITELN('');
      WRITELN('     Please try again.');

      EXIT
    END;

  WRITELN('');
  WRITE('Do you wish to make backup files? (Y/N)  ');

  Ch := READKEY;

  IF Ch IN ['Y','y'] THEN
      MakeBackup := TRUE
    ELSE
      MakeBackup := FALSE;

  WRITELN('');
  WRITELN('');

  RootName := PARAMSTR(1);

  IF (RootName = '/A') OR (RootName = '/a') THEN
    {if all catalogs are to be processed, then cycle through each of them}

    BEGIN

      MaxN := 0;

      FINDFIRST('*.CAT',AnyFile,DirInfo); {finds first .CAT file}

      WHILE DOSError = 0 DO

        BEGIN

          NameFound := FALSE;

          FOR N := 1 TO MaxN DO {check to see if file has already been
                                 processed}

            IF Name_Array[N] = DirInfo.Name THEN NameFound := TRUE;

          IF NOT NameFound THEN

            BEGIN

              INC(MaxN);

              IF MaxN > 100 THEN MaxN := 100;

              Name_Array[MaxN] := DirInfo.Name;  {add file's name to array}

              Process(DirInfo.Name,FileDateTime); {do procedure for this file}

              RootName := COPY(DirInfo.Name,1,POS('.',DirInfo.Name)-1);

              {$I-}

              IF MakeBackup THEN

                BEGIN

                  ASSIGN(TempFile,RootName+'.BAK');
                  RESET(TempFile);

                  IF IOResult = 0 THEN {if backup file exists, erase it}

                    BEGIN

                      CLOSE(TempFile);
                      ERASE(TempFile)
                    END
                END;

              ASSIGN(InFile,RootName+'.CAT');
              ASSIGN(OutFile,RootName+'.$$$');

              IF MakeBackup THEN
                  RENAME(InFile,RootName+'.BAK')
                ELSE
                  ERASE(InFile);

              IF IOResult <> 0 THEN;

              RENAME(OutFile,RootName+'.CAT');
              IF IOResult <> 0 THEN;
              RESET(OutFile);
              SETFTIME(OutFile,FileDateTime);
              CLOSE(OutFile)

              {$I+}
            END;

          FINDNEXT(DirInfo)
        END
    END
    ELSE {only one file is to be processed}
      BEGIN

        Process(RootName,FileDateTime);

        IF POS('.',RootName)<>0 THEN
          RootName := COPY(RootName,1,POS('.',RootName)-1);

        {$I-}

        IF MakeBackup THEN

          BEGIN

            ASSIGN(TempFile,RootName+'.BAK');
            RESET(TempFile);

            IF IOResult = 0 THEN {if backup file exists, erase it}

              BEGIN

                CLOSE(TempFile);
                ERASE(TempFile)
              END
          END;

        ASSIGN(InFile,RootName+'.CAT');
        ASSIGN(OutFile,RootName+'.$$$');

        IF MakeBackup THEN
            RENAME(InFile,RootName+'.BAK')
          ELSE
            ERASE(InFile);

        IF IOResult <> 0 THEN;

        RENAME(OutFile,RootName+'.CAT');
        IF IOResult <> 0 THEN;
        RESET(OutFile);
        SETFTIME(OutFile,FileDateTime);
        CLOSE(OutFile)

        {$I+}
      END
END.
